searchData={"items":[{"type":"module","title":"Monocle","doc":"Test the presence of elements in a rendered component using their data-test attributes,\ndata-test attribute values or a combination of both. This module uses Floki.","ref":"Monocle.html"},{"type":"function","title":"Monocle.we_see_at_least/3","doc":"Checks if an element is present in the rendered component, at least n number of times\n\nThis function is similar to `we_see_exactly/3`, but it checks if the element is present.\nPlease see the documentation for `we_see_exactly/3` for more information.","ref":"Monocle.html#we_see_at_least/3"},{"type":"function","title":"Monocle.we_see_attribute/2","doc":"Checks if an element with a given data-test attribute is present in the rendered component.","ref":"Monocle.html#we_see_attribute/2"},{"type":"function","title":"Example - Monocle.we_see_attribute/2","doc":"Let's say we have the following html code, and we want to check if the confirmation button\nis present in the rendered component:\n\n```html\n Confirm \n```\n\nWe can do so by calling the `we_see_attribute/2` function on the html of the rendered component:\n\n```elixir\nassert we_see_attribute(html, \"confirmation button\")\n```","ref":"Monocle.html#we_see_attribute/2-example"},{"type":"function","title":"Arguments - Monocle.we_see_attribute/2","doc":"html - the html of the rendered component\nattribute - the data-test attribute of the element we want to check for","ref":"Monocle.html#we_see_attribute/2-arguments"},{"type":"function","title":"Monocle.we_see_attribute/3","doc":"Similar to `we_see_attribute/2`, but also checks if the element has the given content.","ref":"Monocle.html#we_see_attribute/3"},{"type":"function","title":"Example - Monocle.we_see_attribute/3","doc":"Let's say we have the following html code, and we want to check if the confirmation button\nis present in the rendered component:\n\n```html\n Confirm \n```\n\nWe can do so by calling the `we_see_attribute/3` function on the html of the rendered component:\n\n```elixir\nassert we_see_attribute(html, \"confirmation button\", content: \"Confirm\")\n```","ref":"Monocle.html#we_see_attribute/3-example"},{"type":"function","title":"Arguments - Monocle.we_see_attribute/3","doc":"html - the html of the rendered component\nattribute - the data-test attribute of the element we want to check for\ncontent - the content of the element we want to check for","ref":"Monocle.html#we_see_attribute/3-arguments"},{"type":"function","title":"Monocle.we_see_attribute_and_value/3","doc":"Checks if an element with a given data-test attribute and value is present in the rendered component.","ref":"Monocle.html#we_see_attribute_and_value/3"},{"type":"function","title":"Example - Monocle.we_see_attribute_and_value/3","doc":"Let's say we have the following html code, and we want to check if the confirmation button\nis present in the rendered component:\n\n```html\n Confirm \n```\n\nWe can do so by calling the `we_see_attribute_and_value/3` function on the html of the rendered component:\n\n```elixir\nassert we_see_attribute_and_value(html, \"confirmation button\", \"confirm\")\n```","ref":"Monocle.html#we_see_attribute_and_value/3-example"},{"type":"function","title":"Arguments - Monocle.we_see_attribute_and_value/3","doc":"html - the html of the rendered component\nattribute - the data-test attribute of the element we want to check for\nattribute_value - the data-test attribute value of the element we want to check for","ref":"Monocle.html#we_see_attribute_and_value/3-arguments"},{"type":"function","title":"Monocle.we_see_attribute_and_value/4","doc":"Similar to `we_see_attribute_and_value/3`, but also checks if the element has the given content.","ref":"Monocle.html#we_see_attribute_and_value/4"},{"type":"function","title":"Example - Monocle.we_see_attribute_and_value/4","doc":"Let's say we have the following html code, and we want to check if the confirmation button\nis present in the rendered component:\n\n```html\n Confirm \n```\n\nWe can do so by calling the `we_see_attribute_and_value/4` function on the html of the rendered component:\n\n```elixir\nassert we_see_attribute_and_value(html, \"confirmation button\", \"confirm\", content: \"Confirm\")\n```","ref":"Monocle.html#we_see_attribute_and_value/4-example"},{"type":"function","title":"Arguments - Monocle.we_see_attribute_and_value/4","doc":"html - the html of the rendered component\nattribute - the data-test attribute of the element we want to check for\nattribute_value - the data-test attribute value of the element we want to check for\ncontent - the content of the element we want to check for","ref":"Monocle.html#we_see_attribute_and_value/4-arguments"},{"type":"function","title":"Monocle.we_see_attribute_value/2","doc":"Checks if an element with a given data-test attribute value is present in the rendered component.","ref":"Monocle.html#we_see_attribute_value/2"},{"type":"function","title":"Example - Monocle.we_see_attribute_value/2","doc":"Let's say we have the following html code, and we want to check if the title is present in the rendered component:\n\n```html\n Title \n```\n\nWe can do so by calling the `we_see_attribute_value/2` function on the html of the rendered component:\n\n```elixir\nassert we_see_attribute_value(html, \"title\")\n```","ref":"Monocle.html#we_see_attribute_value/2-example"},{"type":"function","title":"Arguments - Monocle.we_see_attribute_value/2","doc":"html - the html of the rendered component\nattribute_value - the data-test attribute value of the element we want to check for","ref":"Monocle.html#we_see_attribute_value/2-arguments"},{"type":"function","title":"Monocle.we_see_attribute_value/3","doc":"Similar to `we_see_attribute_value/2`, but also checks if the element has the given content.","ref":"Monocle.html#we_see_attribute_value/3"},{"type":"function","title":"Example - Monocle.we_see_attribute_value/3","doc":"Let's say we have the following html code, and we want to check if the title is present in the rendered component:\n\n```html\n Title \n```\n\nWe can do so by calling the `we_see_attribute_value/3` function on the html of the rendered component:\n\n```elixir\nassert we_see_attribute_value(html, \"title\", content: \"Title\")\n```","ref":"Monocle.html#we_see_attribute_value/3-example"},{"type":"function","title":"Arguments - Monocle.we_see_attribute_value/3","doc":"html - the html of the rendered component\nattribute_value - the data-test attribute value of the element we want to check for\ncontent - the content of the element we want to check for","ref":"Monocle.html#we_see_attribute_value/3-arguments"},{"type":"function","title":"Monocle.we_see_exactly/3","doc":"Checks if an element is present in the rendered component, n number of times","ref":"Monocle.html#we_see_exactly/3"},{"type":"function","title":"Example - Monocle.we_see_exactly/3","doc":"Let's say we have the following html code, and we want to check if buttons are present\nin the rendered component:\n\n```html\n Button \n Button \n```\n\nWe can do so by calling the `we_see_exactly/3` function on the html of the rendered component:\n\n```elixir\nassert we_see_exactly(html, 2, attribute: \"button\")\n```","ref":"Monocle.html#we_see_exactly/3-example"},{"type":"function","title":"Arguments - Monocle.we_see_exactly/3","doc":"html - the html of the rendered component\nnumber - the number of times the element should be present","ref":"Monocle.html#we_see_exactly/3-arguments"},{"type":"function","title":"Optional arguments - Monocle.we_see_exactly/3","doc":"attribute - the data-test attribute of the element we want to check for\ncontent - the content of the element we want to check for\nattribute_value - the data-test attribute value of the element we want to check for\n\nWe can have any combination of the above optional arguments, but we must have at least\none attribute or attribute_value argument. For instance, lets look at the following\nhtml code:\n\n```html\n Button \n Second Button \n Third Button \n Fourth Button \n Fifth Button \n Sixth Button \n```\n\nWe can check the number of buttons by calling the `we_see_exactly/2` function with\nmultiple optional arguments:\n\nWith attribute:\n\n```elixir\nassert we_see_exactly(html, 2, attribute: \"cancellation\")\n```\n\nWith attribute_value:\n\n```elixir\nassert we_see_exactly(html, 2, attribute_value: \"button\")\n```\n\nWith attribute and attribute_value:\n\n```elixir\nassert we_see_exactly(html, 2, attribute: \"optional\", attribute_value: \"option\")\n```\n\nWith attribute and content:\n\n```elixir\nassert we_see_exactly(html, 1, attribute: \"cancellation\", content: \"Third Button\")\n```\n\nWith attribute_value and content:\n\n```elixir\nassert we_see_exactly(html, 1, attribute_value: \"button\", content: \"Second Button\")\n```\n\nWith attribute, attribute_value and content:\n\n```elixir\nassert we_see_exactly(html, 1, attribute: \"optional\", attribute_value: \"option\", content: \"Fifth Button\")\n```","ref":"Monocle.html#we_see_exactly/3-optional-arguments"},{"type":"extras","title":"Monocle","doc":"# Monocle\n\nThis is a library for working with the [Monocle](https://github.com/mohamed-tallarium/Mononcle).\nThis library is built on top of [Floki](https://github.com/philss/floki) and it allows for easier\ntesting of DOM elements in liveview tests.","ref":"readme.html"},{"type":"extras","title":"Usage - Monocle","doc":"Let's say you have a liveview component that looks like this once rendered:\n\n```html\n   \n     Bob Doe \n     23 \n   \n   \n     Alice Smith \n     23 \n   \n```\n\nWe can then test this component like so:\n\n```elixir\n  test \"it renders the users\" do\n    {:ok, view, html} = live(conn, \"/path/to/liveview\")\n\n    assert html|> Monocle.we_see_exactly(2, attribute: \"age\", content: \"23\")\n    assert html|> Monocle.we_see_attribute_and_value(\"user\", \"id-34\")\n    assert html|> Monocle.we_see_attribute_and_value(\"user\", \"id-38\")\n    assert html|> Monocle.we_see_attribute_value(\"name\", content: \"Bob Doe\")\n    assert html|> Monocle.we_see_attribute_value(\"name\", content: \"Alice Smith\")\n  end\n```","ref":"readme.html#usage"},{"type":"extras","title":"Installation - Monocle","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `monocle` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:monocle, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Dependencies - Monocle","doc":"This library depends on [Floki](https://github.com/philss/floki) as it uses the `Floki.find/2` function\nto find elements in the DOM.\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#dependencies"}],"content_type":"text/markdown"}